// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'RSA.pas' rev: 3.00

#ifndef RSAHPP
#define RSAHPP
#include <ComCtrls.hpp>
#include <StdCtrls.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Rsa
{
//-- type declarations -------------------------------------------------------
#pragma pack(push, 1)
struct BigNum
{
	
	union
	{
		Byte Bytes[528];
		Cardinal Contents[132];
		
	};
} ;
#pragma pack(pop)

#pragma pack(push, 1)
struct DoubleBigNum
{
	Cardinal Contents[264];
} ;
#pragma pack(pop)

enum TKeyBits { kb0512, kb1024, kb2048 };

enum TSymKeyLength { sk64, sk128, sk192, sk256 };

typedef Byte TSymKey[32];

class DELPHICLASS ENoKeyLoaded;
class PASCALIMPLEMENTATION ENoKeyLoaded : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall ENoKeyLoaded(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall ENoKeyLoaded(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall ENoKeyLoaded(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall ENoKeyLoaded(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall ENoKeyLoaded(const System::AnsiString Msg, int AHelpContext) : 
		Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall ENoKeyLoaded(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall ENoKeyLoaded(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall ENoKeyLoaded(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~ENoKeyLoaded(void) { }
	
};

class DELPHICLASS EInvalidKey;
class PASCALIMPLEMENTATION EInvalidKey : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EInvalidKey(const System::AnsiString Msg) : Sysutils::Exception(Msg
		) { }
	/* Exception.CreateFmt */ __fastcall EInvalidKey(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EInvalidKey(int Ident, Extended Dummy) : Sysutils::Exception(Ident
		, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EInvalidKey(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EInvalidKey(const System::AnsiString Msg, int AHelpContext) : 
		Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EInvalidKey(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EInvalidKey(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EInvalidKey(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EInvalidKey(void) { }
	
};

class DELPHICLASS TRSA;
class PASCALIMPLEMENTATION TRSA : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	TKeyBits FKeyBits;
	TSymKeyLength FSymKeyLength;
	int FPrecision;
	System::AnsiString FPublicKey;
	System::AnsiString FPrivateKey;
	System::AnsiString FStatus;
	System::AnsiString FSigString;
	Classes::TNotifyEvent FStatusUpdate;
	BigNum Fe;
	BigNum Fn;
	BigNum Fd;
	BigNum FSignature;
	bool FPubkeyLoaded;
	bool FPrivKeyLoaded;
	bool FSigLoaded;
	void __fastcall RSAMakeKeyPair(const BigNum &SeedP, const BigNum &SeedQ, BigNum &e, BigNum &n, BigNum 
		&d);
	void __fastcall SetKeyBits(const TKeyBits Value);
	void __fastcall PutPublicKey(const System::AnsiString Value);
	void __fastcall PutPrivateKey(const System::AnsiString Value);
	void __fastcall PutSignature(const System::AnsiString Value);
	System::AnsiString __fastcall EncodeString(System::AnsiString InputString);
	System::AnsiString __fastcall DecodeString(System::AnsiString InputString);
	int __fastcall GetSymKeyBytes(void);
	void __fastcall BurnString(System::AnsiString &StringToBurn);
	void __fastcall NagRegister(void);
	
protected:
	void __fastcall DoStatusUpdate(void);
	
public:
	__fastcall virtual TRSA(Classes::TComponent* AOwner);
	int __fastcall GetPrecision(void);
	void __fastcall MakeKeyPair(const BigNum &SeedP, const BigNum &SeedQ);
	void __fastcall GetPublicKey(BigNum &Exponent, BigNum &Modulus);
	void __fastcall GetPrivateKey(BigNum &Modulus, BigNum &Inverse);
	void __fastcall SetPublicKey(const BigNum &Exponent, const BigNum &Modulus);
	void __fastcall SetPrivateKey(const BigNum &Modulus, const BigNum &Inverse);
	void __fastcall EncryptString(const System::AnsiString InputString, System::AnsiString &OutputString
		);
	void __fastcall DecryptString(const System::AnsiString InputString, System::AnsiString &OutputString
		);
	void __fastcall Sign(const Byte * Hash, const int Hash_Size, const int DigestLength);
	bool __fastcall Verify(const Byte * Hash, const int Hash_Size, const int DigestLength);
	System::AnsiString __fastcall EncryptKey(const Byte * SymKey);
	void __fastcall DecryptKey(const System::AnsiString EncryptedKey, Byte * SymKey);
	void __fastcall Burn(void);
	System::AnsiString __fastcall GetVersion(void);
	
__published:
	__property TKeyBits KeyBits = {read=FKeyBits, write=SetKeyBits, nodefault};
	__property System::AnsiString PublicKey = {read=FPublicKey, write=PutPublicKey};
	__property System::AnsiString PrivateKey = {read=FPrivateKey, write=PutPrivateKey};
	__property System::AnsiString Signature = {read=FSigString, write=PutSignature};
	__property System::AnsiString Status = {read=FStatus, write=FStatus};
	__property TSymKeyLength SymKeyLength = {read=FSymKeyLength, write=FSymKeyLength, nodefault};
	__property Classes::TNotifyEvent OnStatusUpdate = {read=FStatusUpdate, write=FStatusUpdate};
public:
		
	/* TComponent.Destroy */ __fastcall virtual ~TRSA(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
#define SEIVE (Word)(6000)
#define PRIMES (Word)(800)
#define SS (Word)(2000)
#define MAX_DIGITS (Byte)(132)
extern PACKAGE void __fastcall Register(void);

}	/* namespace Rsa */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Rsa;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// RSA
